"use strict";
cc._RF.push(module, '28d054PqhhLiZ/gbnyMHfrM', 'Game');
// Game.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Game = /** @class */ (function (_super) {
    __extends(Game, _super);
    function Game() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.describe = null;
        _this.storyArr = [
            '每次我不知道说什么的时候我就不知道说什么。',
            '同一个小区里的邻居，他们家的孩子六年级就开始上六年级的课了。我家的孩子三年级，还在上三年级的课',
            '经过我细密的观察，我发现我出生的哪一天竟然是我的生日',
            '如果你登上了珠穆朗玛峰山顶，那么你就具备了登上珠穆朗玛峰山顶的能力',
            '如果你愿意多花一点事件读完，那么你就会发现你多花了一点时间',
        ];
        _this.storyIdx = 0;
        return _this;
    }
    Game.prototype.onLoad = function () {
        this.describe.string = '';
    };
    Game.prototype.onBtnPlayTypewriterEffect = function () {
        var _this = this;
        var str = this.storyArr[this.storyIdx];
        this.playTypewriterAnim(this.describe, str, 1000, function () {
            _this.storyIdx++;
            if (_this.storyIdx >= _this.storyArr.length)
                _this.storyIdx = 0;
            console.log('finish~~~');
        });
    };
    /**
     * 富文本打字机
     * @param {cc.RichText} animLab 富文本组件
     * @param {string} storyStr 文本
     * @param {number} speed 打字机速度
     * @param {Function} callback 打字完成回调
     */
    Game.prototype.playTypewriterAnim = function (animLab, storyStr, speed, callback) {
        if (speed === void 0) { speed = 1000; }
        animLab.string = '';
        animLab.node.removeAllChildren();
        animLab.string = storyStr;
        //富文本RichText组件是分为多个文本Label组件实现的，这一点在私有属性_labelSegments中可以发现
        var _labelSegments = animLab._labelSegments;
        var delay = 0;
        var tweenAnim = [];
        for (var i = 0; i < _labelSegments.length; i++) {
            var element = _labelSegments[i];
            console.log(element.getComponent(cc.Label).string + ' x:' + element.x + ' y:' + element.y);
            var maskNode = new cc.Node();
            maskNode.name = "mask" + i;
            maskNode.addComponent(cc.Mask);
            maskNode.anchorX = element.anchorX;
            maskNode.anchorY = element.anchorY;
            maskNode.x = element.x + animLab.node.width / 2;
            maskNode.y = element.y - animLab.node.height / 2;
            maskNode.setContentSize(element.getContentSize());
            element.parent = maskNode;
            element.x = 0;
            element.y = 0;
            element.anchorX = 0.5;
            element.anchorY = 0.5;
            animLab.node.addChild(maskNode);
            var width = maskNode.width;
            var dur = width / speed;
            tweenAnim.push({ node: maskNode, delay: delay, dur: dur, width: width });
            delay += dur;
        }
        animLab.string = '';
        var parentY = animLab.node.y;
        animLab.node.y = 2600;
        this.scheduleOnce(function () {
            for (var i = 0; i < tweenAnim.length; i++) {
                var element = tweenAnim[i];
                element.node.width = 0;
                if (i < tweenAnim.length - 1) {
                    cc.tween(element.node).delay(element.delay).to(element.dur, { width: element.width }).start();
                }
                else {
                    cc.tween(element.node).delay(element.delay).to(element.dur, { width: element.width }).call(function () {
                        if (callback)
                            callback();
                    }).start();
                }
            }
            animLab.node.y = parentY;
        }, 0);
    };
    __decorate([
        property(cc.RichText)
    ], Game.prototype, "describe", void 0);
    Game = __decorate([
        ccclass
    ], Game);
    return Game;
}(cc.Component));
exports.default = Game;

cc._RF.pop();